<?php
/**
 * @fileID: $Id: helper.php 7818 2012-02-16 05:40:43Z alfiya $
 * @changedDate: $LastChangedDate: 2012-02-16 12:40:43 +0700 (Thu, 16 Feb 2012) $
 * @changedBy: $LastChangedBy: alfiya $
 * MightyCommerce ShoppingCart module by Mighty Extensions
 * a module for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

class modCommerceCartHelper
{
	function getItemsList($section_id )
	{
		$db	=& JFactory::getDBO();
		$session =& JFactory::getSession();
		$dispatcher =& JDispatcher::getInstance();

		$cart = $session->get('my_cart'.'-'.$section_id);
		$sum = 0;
		$price = array();
		$items = array();
		$count = 0;
		if(count($cart) > 0)
		{
			$core = modCommerceCartHelper::getCore($section_id);

			$id = 0;
			foreach($cart as $seller_id => $list)
			{
				foreach($list as $k => $item)
				{
					$article 	= modCommerceCartHelper::getArticleInfo($item->article);
					//$price 		= modCommerceCartHelper::getPrice($item->article, $item->items_num);
	
					JPluginHelper::importPlugin('joomsuite_content_fields', 'price');
					$price = 0;
					$dispatcher->trigger('onGetItemPrice', array (&$price, $item->article, $item->items_num, 'as_is', true));
					
					$items[$id]->title = $article->title;
					$items[$id]->link = $item->link;
	
					$items[$id]->price = $price;
	
					$items[$id]->amount = $item->items_num;
					
					$count += $item->items_num;
	
					$items[$id]->sum = round($price * $item->items_num, 2);
					$items[$id]->total = round($price * $item->items_num, 2);
	
					$items[$id]->total = str_replace("00", $items[$id]->total, $core->format);
					$items[$id]->total = str_replace("Sign", $core->mark, $items[$id]->total);
	
					$items[$id]->price = str_replace("00", round($items[$id]->price, 2), $core->format);
					$items[$id]->price = str_replace("Sign", $core->mark, $items[$id]->price);
					
					$items[$id]->remove = $seller_id.'::'.$k;
	
					$id ++;
				}
			}
			foreach ($items as $item)
				$sum += $item->sum;
			$sum = str_replace("00", $sum, $core->format);
			$sum = str_replace("Sign", $core->mark, $sum);

		}
		$result = array($items, $sum, $count);
		return $result;
	}

	function getArticleInfo($id)
	{
		$db	=& JFactory::getDBO();
		$sql = "SELECT * FROM #__js_res_record WHERE id='$id'";
		$db->setQuery($sql);
		return $db->loadObject();
	}

	function getPrice($id, $item_amount)
	{
		$db	=& JFactory::getDBO();
		$catid = ResHelper::getArticleSection($id);
		$CP = ResHelper::getSectionParams($catid);
		if(!$CP->get('comm_enabled', 0)) return;
		
		$sql = "SELECT v.field_value
			FROM #__js_res_record_values v
 		  	JOIN #__js_res_record r ON v.record_id = r.id 
 		  	JOIN #__js_res_fields f ON v.field_id = f.id
 		  	WHERE r.id = '".$id."' AND f.type='price'";
		$db->setQuery($sql);
		$price = $db->loadResult();
		$cur = $CP->get('comm_core_currency');
		
		$sql = "SELECT value FROM #__js_res_field_extra WHERE ref_id = 'price_ext' AND record_id = '{$id}'";
		$db->setQuery($sql);
		$price = round($price, 2);
		if($extra = $db->loadResult())
		{
			$val = unserialize($extra);

			if(isset($val['extra']))
			{
				$position = -1;
				foreach ($val['extra']['min_amount'] as $key => $amount)
				{
					if($item_amount >= $amount)
					$position = $key;
				}
				if($position != -1)
				$price = $val['extra']['price'][$position];
				if(isset($val['currency_id']) && $val['currency_id'] != $cur )
				{
					$sql = "SELECT uc.rate
					FROM #__jc_users_currencies uc
					WHERE uc.currency_id = '{$val['currency_id']}'
					AND uc.section_id = ".$catid;
					$db->setQuery($sql);
					$rate = $db->loadResult();
					$price = $price / $rate;
				}
			}
				
			if($val['tax_id'])
			{
				$sql = "SELECT rate, name FROM #__jc_taxes WHERE id = '{$val['tax_id']}'";
				$db->setQuery($sql);
				$tax = $db->loadObject();
				$price += $price * $tax->rate / 100;
			}
		}
		return $price;
	}

	function getCurrencyInfo($id)
	{
		$db = & Jfactory::getDBO();
		$sql = "SELECT  uc.rate FROM #__jc_users_currencies uc WHERE uc.currency_id = '$id'";
		$db->setQuery($sql);
		return $db->loadObject();
	}

	function getTaxInfo($id)
	{
		$db = & Jfactory::getDBO();
		$sql = "SELECT t.rate  FROM #__jc_taxes t WHERE t.id = '$id'";
		$db->setQuery($sql);
		//echo $db->_sql;
		return $db->loadObject();
	}

	function getCore($section_id)
	{
		$db =& JFactory::getDBO();
		require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'library'.DS.'helper.php');
		$comm_params = ResHelper::getSectionParams($section_id);

		require_once (JPATH_ROOT.DS.'administrator/components/com_commerce/controllers'.DS.'config.php');
		CommerceControllerConfig::initialyze($comm_params, $section_id);

		$query = "
           SELECT c.code, IF(c.mark != '', c.mark, c.code) as mark
             FROM #__jc_currency AS c
            WHERE c.id = ". $comm_params->get('comm_core_currency');
		$db->setQuery( $query);
		$row = $db->loadObject();
		$row->format = COMM_LAYOUT_PRICE;
		return $row;
	}

}
?>